/* 
 * Leaflet GeoJSON Selector v0.3.5 - 2016-03-23 
 * 
 * Copyright 2016 Stefano Cudini 
 * stefano.cudini@gmail.com 
 * http://labs.easyblog.it/ 
 * 
 * Licensed under the MIT license. 
 * 
 * Demo: 
 * http://labs.easyblog.it/maps/leaflet-geojson-selector/ 
 * 
 * Source: 
 * git@github.com:stefanocudini/leaflet-geojson-selector.git 
 * 
 */
(function(){L.Control.GeoJSONSelector=L.Control.extend({includes:L.Mixin.Events,options:{collapsed:!1,position:"bottomleft",listLabel:"properties.name",listSortBy:null,listItemBuild:null,activeListFromLayer:!0,zoomToLayer:!1,listOnlyVisibleLayers:!1,multiple:!1,style:{color:"#00f",fillColor:"#08f",fillOpacity:.4,opacity:1,weight:1},activeClass:"active",activeStyle:{color:"#00f",fillColor:"#fc0",fillOpacity:.6,opacity:1,weight:1},selectClass:"selected",selectStyle:{color:"#00f",fillColor:"#f80",fillOpacity:.8,opacity:1,weight:1}},initialize:function(a,b){L.Util.setOptions(this,b||{});this.options.listSortBy=this.options.listSortBy||this.options.listLabel,this.options.listItemBuild&&(this._itemBuild=this.options.listItemBuild),this._layer=a},onAdd:function(a){var b=L.DomUtil.create("div","geojson-list");return this._baseName="geojson-list",this._map=a,this._container=b,this._id=this._baseName+L.stamp(this._container),this._list=L.DomUtil.create("ul","geojson-list-group",b),this._items=[],L.DomEvent.on(b,"mouseover",function(b){a.scrollWheelZoom.disable()}).on(b,"mouseout",function(b){a.scrollWheelZoom.enable()}),this.options.listOnlyVisibleLayers&&a.on("moveend",this._updateListVisible,this),a.whenReady(function(c){b.style.height=a.getSize().y+"px"}),this._initToggle(),this._updateList(),b},onRemove:function(a){a.off("moveend",this._updateList,this)},reload:function(a){return this._layer=a,this._updateList(),this},_getPath:function(a,b){var c=b.split("."),d=c.pop(),e=c.length,f=c[0],g=1;if(e>0)for(;(a=a[f])&&e>g;)f=c[g++];return a?a[d]:void 0},_itemBuild:function(a){return this._getPath(a.feature,this.options.listLabel)||"&nbsp;"},_selectItem:function(a,b){for(var c=0;c<this._items.length;c++)L.DomUtil.removeClass(this._items[c],this.options.selectClass);b&&L.DomUtil.addClass(a,this.options.selectClass)},_selectLayer:function(a,b){for(var c=0;c<this._items.length;c++)this._items[c].layer.setStyle&&this._items[c].layer.setStyle(this.options.style);b&&a.setStyle&&a.setStyle(this.options.selectStyle)},_createItem:function(a){var b=this,c=L.DomUtil.create("li","geojson-list-item"),d=document.createElement("label"),e=this.options.multiple?"checkbox":"radio",f=this._createInputElement(e,this._id,!1),g=this._itemBuild.call(this,a);return d.innerHTML=g,d.insertBefore(f,d.firstChild),c.appendChild(d),c.layer=a,a.itemList=c,a.itemLabel=d,L.DomEvent.on(d,"click",L.DomEvent.stop,this).on(d,"click",function(d){b.options.zoomToLayer&&b._moveTo(a),f.checked=!f.checked,c.selected=f.checked,b._selectItem(c,f.checked),b._selectLayer(a,f.checked),b.fire("change",{selected:f.checked,layers:[a]})},this),L.DomEvent.on(c,"mouseover",function(a){L.DomUtil.addClass(a.target,this.options.activeClass);for(var c=0;c<b._items.length;c++)b._items[c]||b._items[c].layer.setStyle(b.options.activeStyle)},this).on(c,"mouseout",function(a){L.DomUtil.removeClass(a.target,b.options.activeClass);for(var c=0;c<b._items.length;c++)b._items[c]||b._items[c].layer.setStyle(b.options.style)},this),this._items.push(c),c},_createInputElement:function(a,b,c){var d='<input type="'+a+'" name="'+b+'"';c&&(d+=' checked="checked"'),d+="/>";var e=document.createElement("div");return e.innerHTML=d,e.firstChild},_updateList:function(){var a=this,b=[],c=this.options.listSortBy;this._list.innerHTML="",this._layer.eachLayer(function(c){b.push(c),c.setStyle&&c.setStyle(a.options.style),a.options.activeListFromLayer&&c.on("click",L.DomEvent.stop).on("click",function(a){c.itemLabel.click()}).on("mouseover",function(b){c.setStyle&&c.setStyle(a.options.activeStyle),L.DomUtil.addClass(c.itemList,a.options.activeClass)}).on("mouseout",function(b){c.setStyle&&c.setStyle(a.options.style),L.DomUtil.removeClass(c.itemList,a.options.activeClass)})}),b.sort(function(b,d){var e=a._getPath(b.feature,c),f=a._getPath(d.feature,c);return f>e?-1:e>f?1:0});for(var d=0;d<b.length;d++)this._list.appendChild(this._createItem(b[d]))},_updateListVisible:function(){var a,b=this;this._layer.eachLayer(function(c){c.getBounds?a=b._map.getBounds().intersects(c.getBounds()):c.getLatLng&&(a=b._map.getBounds().contains(c.getLatLng())),c.itemList.style.display=a?"block":"none"})},_initToggle:function(){var a=this._container;if(a.setAttribute("aria-haspopup",!0),L.Browser.touch?L.DomEvent.on(a,"click",L.DomEvent.stopPropagation):L.DomEvent.disableClickPropagation(a),this.options.collapsed){this._collapse(),L.Browser.android||L.DomEvent.on(a,"mouseover",this._expand,this).on(a,"mouseout",this._collapse,this);var b=this._button=L.DomUtil.create("a","geojson-list-toggle",a);b.href="#",b.title="List GeoJSON",L.Browser.touch?L.DomEvent.on(b,"click",L.DomEvent.stop).on(b,"click",this._expand,this):L.DomEvent.on(b,"focus",this._expand,this),this._map.on("click",this._collapse,this)}},_expand:function(){this._container.className=this._container.className.replace(" geojson-list-collapsed","")},_collapse:function(){L.DomUtil.addClass(this._container,"geojson-list-collapsed")},_moveTo:function(a){var b=this.options.position,c=(this._map._controlCorners[b].clientWidth,new L.Point(this._container.clientWidth,this._container.clientHeight)),d={paddingTopLeft:null,paddingBottomRight:null};-1!==b.indexOf("right")?d.paddingBottomRight=L.point(c.x,0):-1!==b.indexOf("left")&&(d.paddingTopLeft=L.point(c.x,0)),a.getBounds?this._map.fitBounds(a.getBounds(),d):a.getLatLng&&this._map.setView(a.getLatLng())}}),L.control.geoJsonSelector=function(a,b){return new L.Control.GeoJSONSelector(a,b)}}).call(this);